<?php
class AllegroKomentarz extends Module {
	private $html = '';
	
	function __construct() {
		$this->name = 'allegrokomentarz';		
		parent::__construct();
				
		$this->tab = 'Blocks';
		$this->version = '0.2';
		$this->displayName = $this->l('Allegro - Komentarze');
		$this->description = $this->l('Dodaje blok z losowymi pozytuwnymi komentarzami uzytkownika allegro.');	
				
	}
	public function install() {
		if(!parent::install() || !$this->registerHook('leftColumn') || !Configuration::updateValue($this->name.'nbc', 3) || !function_exists('curl_init') || !Configuration::updateValue($this->name.'headerTmp', 'Komentarze %s'))
			return false;
		else return true;
	}
	public function uninstall() {
		Configuration::deleteByName($this->name.'uid');
		Configuration::deleteByName($this->name.'nbc');
		Configuration::deleteByName($this->name.'userName');
		Configuration::deleteByName($this->name.'headerTmp');
		if(!parent::uninstall())
			return false;
		else return true;
	}
	public function getContent() {
		if(Tools::isSubmit('submitConf')) {
			$git = true;
			if(!Validate::isUnsignedInt(Tools::getValue('uid'))) {
				$this->html .= $this->displayError('Integer expected in UID');
				$git = false;
			} elseif(!Validate::isUnsignedInt(Tools::getValue('nbc'))) {
				$this->html .= $this->displayError('Integer expected in Number of comments');
				$git = false;
			}
			if($git and (Tools::getValue('uid', 0) != Configuration::get($this->name.'uid') or Tools::getValue('userName') == '')) {
				$un = $this->getUserName(Tools::getValue('uid'));
				if($un) {
					Configuration::updateValue($this->name.'userName', $un);
					$this->html .= $this->displayConfirmation($this->l('Username generated automatically. If it\'s incorrect change it manually.'));
				}
			} elseif(Tools::getValue('userName') != Configuration::get($this->name.'userName')) {
				if(Configuration::updateValue($this->name.'userName', Tools::getValue('userName')) ) {
					$this->html .= $this->displayConfirmation($this->l('Successfully changed username.'));
				} else {
					$this->html .= $this->displayError($this->l('Error during saving username.'));
				}
			}
			if($git and Configuration::updateValue($this->name.'uid', Tools::getValue('uid', 0)) and Configuration::updateValue($this->name.'nbc', Tools::getValue('nbc', 3))  and Configuration::updateValue($this->name.'headerTmp', Tools::getValue('headerTmp', 'Komentarze %s'))) {
				$this->html .= $this->displayConfirmation($this->l('Successfully saved settings.'));
			} else {
				$this->html .= $this->displayError($this->l('Error during saving settings.'));
			}
		}
		$this->html .= '<fieldset>
							<legend>'.$this->l('Information').'</legend>
							<h3>'.$this->l('Created by ').'OpenIdeas.pl'.$this->l('. You can find our other products at ').'prestamarket.pl'.'</h3>
						</fieldset><br />';
		$this->html .= '<fieldset>
								<legend>'.$this->l('Settings').'</legend>
								<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
									<label>'.$this->l('allegro UID').'</label>
									<div class="margin-form">
										<input type="text" name="uid" value="'.(Tools::getValue('uid', Configuration::get($this->name.'uid'))).'" />
										<p class="clear">'.$this->l('Can be found at user\'s `home` site, look at the URL: http://allegro.pl/show_user.php?uid=HERE\'s.').'</p>
									</div>';
		if(Configuration::get($this->name.'uid')) {
			$this->html .=			'<label>'.$this->l('allegro UserName').'</label>
									<div class="margin-form">
										<input type="text" name="userName" value="'.Configuration::get($this->name.'userName').'" />
									</div>';
		}
		$this->html .=				'<label>'.$this->l('Header template').'</label>
									<div class="margin-form">
										<input type="text" name="headerTmp" value="'.(Tools::getValue('headerTmp', Configuration::get($this->name.'headerTmp'))).'" />
										<p class="clear">'.$this->l('String in block header, %s is replaced by username.').'</p>
									</div>																
									<label>'.$this->l('Nb. of comments').'</label>
									<div class="margin-form">
										<input type="text" name="nbc" value="'.(Tools::getValue('nbc', Configuration::get($this->name.'nbc'))).'" />
										<p class="clear">'.$this->l('Number of commnets displayed in block.').'</p>
									</div>																
									<input type="submit" name="submitConf" value="'.$this->l('Save').'" class="button" />
								</form>
							 </fieldset><br />';
		return $this->html;
	}
	
	public function hookLeftColumn($params) {
		global $smarty;
		$smarty->assign(array(
						'username_ALK' => sprintf(Configuration::get($this->name.'headerTmp'),Configuration::get($this->name.'userName')),
						'uid_ALK' => Configuration::get($this->name.'uid'),
						'link_ALK' => _MODULE_DIR_.$this->name.'/ajax-komentarze.php',
						'linkdojs_ALK' => _MODULE_DIR_.$this->name.'/js/ajax.js'
						));
		return $this->display(__FILE__, 'blockkomentarze.tpl');
	}
	public function hookRightColumn($params) {
		return $this->hookLeftColumn($params);
	}
	public function hookAjax() {
		global $smarty;
		$smarty->assign(array(
						'komentarze_ALK' => $this->getComments()
						));
		
		return $this->display(__FILE__, 'ajax-komentarze.tpl');
	}
	
	private function getUserName($uid) {
		$url = 'http://allegro.pl/show_user.php?uid='.$uid.'&type=fb_all&feedback_type=fb_recvd_pos';
		$c = curl_init();
		curl_setopt_array($c, array(
										CURLOPT_URL => $url,
										CURLOPT_RETURNTRANSFER => true,
										CURLOPT_HEADER => 0,
										CURLOPT_TIMEOUT => 20
									));
		$d = curl_exec($c);
		preg_match('/<span class="fontcolor2">\s*<span class="uname">(\w+)<\/span>/', $d, $name);
		return $name[1];
	}
	
	private function getComments() {
		$uid = Configuration::get($this->name.'uid');
		if($uid == NULL) return false;
		$url = 'http://allegro.pl/show_user.php?uid='.$uid.'&type=fb_all&feedback_type=fb_recvd_pos';
		$c = curl_init();
		curl_setopt_array($c, array(
										CURLOPT_URL => $url,
										CURLOPT_RETURNTRANSFER => true,
										CURLOPT_HEADER => 0,
										CURLOPT_TIMEOUT => 20
									));
		$d = curl_exec($c);
		preg_match_all(
		//'#<tr><td class="list-(?:white|color) center_txt" style="text-align: right"><span style="float: left;"><span class="uname"> <a href="(?:.+)" >(\w+)</a></span>(?:.*)<div class="toleft">(.+)<tr>(?:.+)</div></td></tr></tr>#'
//		'#<li class="list-(?:white|color)">\s*<ul class="feedbacks_row">\s*<li class="col1">\s*<span class="feedback_left_space">\s*<span class="uname">\s*<a href="(?:.+)"\s*>(\w+)</a></span>(?:.*)</ul>\s*<p class="">(.+)</p>#'
		'#<li class="list-(?:white|color)">\s*<ul class="feedbacks_row">\s*<li class="col1">\s*<span class="feedback_left_space">\s*<span class="uname">\s*<a href="(?:.+)" >(\w+)</a></span>(?:\s|.)*?<p class="">(.+)</p>#'
		,$d, $koment);

		foreach($koment[2] as $k=>$val) {   
			$res2[$val] = $k;
		}
		$koment[2] = array_flip($res2); 
		$count = sizeof($koment[2]);
		if($count <= Configuration::get($this->name.'nbc'))
			$nbofc = $count;
		else
			$nbofc = Configuration::get($this->name.'nbc');
		$rand = array_rand($koment[2], $nbofc);
		if($nbofc == 1) $rand = array($rand);
		$dane = array();
		foreach($rand as $v)
			$dane[] = array('nick' => $koment[1][$v], 'kom' => $koment[2][$v]);
		return $dane;
	}
}
?>